## watcher 0.1.0

=== CMakeLists.txt ===
#
# Copyright (c) 2014-2025 Enrico M. Crisostomo
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 3, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
#
# You should have received a copy of the GNU General Public License along with
# this program.  If not, see <http://www.gnu.org/licenses/>.
#
cmake_minimum_required(VERSION 3.14)
project(fswatch VERSION 1.18.2 LANGUAGES C CXX)

#@formatter:off
set(PACKAGE           "${PROJECT_NAME}")
set(PACKAGE_NAME      "${PACKAGE}")
set(PACKAGE_VERSION   "${PROJECT_VERSION}")
set(PACKAGE_STRING    "${PACKAGE_NAME} ${PACKAGE_VERSION}")
set(PACKAGE_AUTHOR    "enrico.m.crisostomo@gmail.com")
set(PACKAGE_BUGREPORT "${PACKAGE_AUTHOR}")
set(PACKAGE_TARNAME   "${PACKAGE}")
set(PACKAGE_URL       "https://github.com/emcrisostomo/${PACKAGE}")
set(LOCALEDIR         "${CMAKE_INSTALL_PREFIX}/share/locale" CACHE FILEPATH "locale dir")
#@formatter:on

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

set(CMAKE_POSITION_INDEPENDENT_CODE ON)
set(CMAKE_BUILD_TYPE Release)
set(CMAKE_COLOR_MAKEFILE OFF)
set(CMAKE_INSTALL_MESSAGE NEVER)

# Add option to choose between shared and static libraries
option(BUILD_SHARED_LIBS "Build shared libraries" OFF)

# include modules
include(FindGettext)
include(FindIntl)
include(CheckIncludeFileCXX)
include(CheckStructHasMember)
include(CheckCXXSymbolExists)

add_subdirectory(libfswatch)

=== DESCRIPTION ===
Package: watcher
Type: Package
Title: Watch the File System for Changes
Version: 0.1.0
Authors@R: 
    c(person(given = "Charlie",
             family = "Gao",
             role = c("aut", "cre"),
             email = "charlie.gao@shikokuchuo.net",
             comment = c(ORCID = "0000-0002-0750-061X")),
      person(given = "Posit Software, PBC",
             role = "cph"))
Description: R binding for 'libfswatch', a file system monitoring library. Watch
    files, or directories recursively, for changes in the background. Log
    activity, or run an R function every time a change event occurs. 
License: MIT + file LICENSE
BugReports: https://github.com/r-lib/watcher/issues
URL: https://r-lib.github.io/watcher/,
        https://github.com/r-lib/watcher/
Encoding: UTF-8
SystemRequirements: 'libfswatch', or 'cmake' to compile from package
        sources
Depends: R (>= 3.6)
Imports: later, R6, rlang
Suggests: testthat (>= 3.0.0)
RoxygenNote: 7.3.2
Config/testthat/edition: 3
Config/Needs/website: tidyverse/tidytemplate
NeedsCompilation: yes
Packaged: 2025-02-05 21:55:22 UTC; cg334
Author: Charlie Gao [aut, cre] (<https://orcid.org/0000-0002-0750-061X>),
  Posit Software, PBC [cph]
Maintainer: Charlie Gao <charlie.gao@shikokuchuo.net>
Repository: CRAN
Date/Publication: 2025-02-06 14:20:02 UTC

=== libfswatch/CMakeLists.txt ===
#
# Copyright (c) 2014-2024 Enrico M. Crisostomo
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 3, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
#
# You should have received a copy of the GNU General Public License along with
# this program.  If not, see <http://www.gnu.org/licenses/>.
#

# Define symbols to conditionally define FSEvents flags
if(APPLE)
    if (${CMAKE_SYSTEM_VERSION} VERSION_GREATER_EQUAL "9.0")
        set(HAVE_MACOS_GE_10_5 1)
    endif()

    if (${CMAKE_SYSTEM_VERSION} VERSION_GREATER_EQUAL "11.0")
        set(HAVE_MACOS_GE_10_7 1)
    endif()

    if (${CMAKE_SYSTEM_VERSION} VERSION_GREATER_EQUAL "13.0")
        set(HAVE_MACOS_GE_10_9 1)
    endif()

    if (${CMAKE_SYSTEM_VERSION} VERSION_GREATER_EQUAL "14.0")
        set(HAVE_MACOS_GE_10_10 1)
    endif()

    if (${CMAKE_SYSTEM_VERSION} VERSION_GREATER_EQUAL "17.0")
        set(HAVE_MACOS_GE_10_13 1)
    endif()
endif()

set(LIBFSWATCH_HEADER_FILES
        src/libfswatch/c/cevent.h
        src/libfswatch/c/cfilter.h
        src/libfswatch/c/cmonitor.h
        src/libfswatch/c/error.h
        src/libfswatch/c/libfswatch.h
        src/libfswatch/c/libfswatch_log.h
        src/libfswatch/c/libfswatch_types.h
        src/libfswatch/c++/event.hpp
        src/libfswatch/c++/filter.hpp
        src/libfswatch/c++/libfswatch_exception.hpp
        src/libfswatch/c++/monitor.hpp
        src/libfswatch/c++/monitor_factory.hpp
        src/libfswatch/c++/path_utils.hpp
        src/libfswatch/c++/poll_monitor.hpp
        src/libfswatch/c++/string/string_utils.hpp
        src/libfswatch/gettext.h
        src/libfswatch/gettext_defs.h
        ${CMAKE_CURRENT_BINARY_DIR}/libfswatch_config.h)

set(LIB_SOURCE_FILES
        src/libfswatch/c/cevent.cpp
        src/libfswatch/c/libfswatch.cpp
        src/libfswatch/c/libfswatch_log.cpp
        src/libfswatch/c++/event.cpp
        src/libfswatch/c++/filter.cpp
        src/libfswatch/c++/libfswatch_exception.cpp
        src/libfswatch/c++/monitor.cpp
        src/libfswatch/c++/monitor_factory.cpp
        src/libfswatch/c++/path_utils.cpp
        src/libfswatch/c++/poll_monitor.cpp
        src/libfswatch/c++/string/string_utils.cpp)

check_struct_has_member("struct stat" st_mtime sys/stat.h HAVE_STRUCT_STAT_ST_MTIME)
check_struct_has_member("struct stat" st_mtimespec sys/stat.h HAVE_STRUCT_STAT_ST_MTIMESPEC)

check_include_file_cxx(sys/inotify.h HAVE_SYS_INOTIFY_H)

if (HAVE_SYS_INOTIFY_H)
    set(LIBFSWATCH_HEADER_FILES
            ${LIBFSWATCH_HEADER_FILES}
            src/libfswatch/c++/inotify_monitor.hpp)
    set(LIB_SOURCE_FILES
            ${LIB_SOURCE_FILES}
            src/libfswatch/c++/inotify_monitor.cpp)
endif (HAVE_SYS_INOTIFY_H)

check_include_file_cxx(sys/event.h HAVE_SYS_EVENT_H)

if (HAVE_SYS_EVENT_H)
    set(LIBFSWATCH_HEADER_FILES
            ${LIBFSWATCH_HEADER_FILES}
            src/libfswatch/c++/kqueue_monitor.hpp)
    set(LIB_SOURCE_FILES
            ${LIB_SOURCE_FILES}
            src/libfswatch/c++/kqueue_monitor.cpp)
endif (HAVE_SYS_EVENT_H)

check_include_file_cxx(port.h HAVE_PORT_H)

if (HAVE_PORT_H)
    set(LIBFSWATCH_HEADER_FILES
            ${LIBFSWATCH_HEADER_FILES}
            src/libfswatch/c++/fen_monitor.hpp)
    set(LIB_SOURCE_FILES
            ${LIB_SOURCE_FILES}
            src/libfswatch/c++/fen_monitor.cpp)
endif (HAVE_PORT_H)

check_cxx_symbol_exists(FindFirstChangeNotification windows.h HAVE_WINDOWS_HEADER)

if (HAVE_WINDOWS_HEADER)

    set(LIBFSWATCH_HEADER_FILES
                ${LIBFSWATCH_HEADER_FILES}
                src/libfswatch/c++/windows/win_directory_change_event.hpp
                src/libfswatch/c++/windows/win_error_message.hpp
                src/libfswatch/c++/windows/win_handle.hpp
                src/libfswatch/c++/windows/win_paths.hpp
                src/libfswatch/c++/windows/win_strings.hpp
                src/libfswatch/c++/windows_monitor.hpp)
                
    set(LIB_SOURCE_FILES
                ${LIB_SOURCE_FILES}
                src/libfswatch/c++/windows/win_directory_change_event.cpp
                src/libfswatch/c++/windows/win_error_message.cpp
                src/libfswatch/c++/windows/win_handle.cpp
                src/libfswatch/c++/windows/win_paths.cpp
                src/libfswatch/c++/windows/win_strings.cpp
                src/libfswatch/c++/windows_monitor.cpp)
    
    set(HAVE_WINDOWS ON CACHE BOOL "Enable Windows support")
        
endif (HAVE_WINDOWS_HEADER)

if (APPLE)
    check_include_file_cxx(CoreServices/CoreServices.h HAVE_FSEVENTS_FILE_EVENTS)

    if (HAVE_FSEVENTS_FILE_EVENTS)
        find_library(CORESERVICES_LIBRARY CoreServices)

        if (CORESERVICES_LIBRARY)
            set(CMAKE_REQUIRED_LIBRARIES ${CORESERVICES_LIBRARY})
            check_symbol_exists(FSEventStreamSetDispatchQueue "CoreServices/CoreServices.h" HAVE_FSEVENTS_FSEVENTSTREAMSETDISPATCHQUEUE)

            if (HAVE_FSEVENTS_FSEVENTSTREAMSETDISPATCHQUEUE)
                set(EXTRA_LIBS ${EXTRA_LIBS} ${CORESERVICES_LIBRARY})
                set(LIBFSWATCH_HEADER_FILES
                    ${LIBFSWATCH_HEADER_FILES}
                    src/libfswatch/c++/fsevents_monitor.hpp)
                set(LIB_SOURCE_FILES
                    ${LIB_SOURCE_FILES}
                    src/libfswatch/c++/fsevents_monitor.cpp)
            endif (HAVE_FSEVENTS_FSEVENTSTREAMSETDISPATCHQUEUE)
        endif ()
    endif (HAVE_FSEVENTS_FILE_EVENTS)
endif (APPLE)

# Add a configuration file processed by cmake
configure_file(libfswatch_config.in libfswatch_config.h)
# TODO: consider removing it
add_definitions(-DHAVE_LIBFSWATCH_CONFIG_H)

add_library(libfswatch ${LIB_SOURCE_FILES} ${LIBFSWATCH_HEADER_FILES})
set_target_properties(libfswatch PROPERTIES PREFIX "")

# check for gettext and libintl
if (USE_NLS)
    if (Intl_LIBRARIES)
        target_link_libraries(libfswatch PRIVATE ${Intl_LIBRARIES})
    endif ()
endif ()

target_include_directories(libfswatch PUBLIC src/libfswatch)
target_include_directories(libfswatch PUBLIC src)
target_include_directories(libfswatch PUBLIC ${Intl_INCLUDE_DIRS})
target_include_directories(libfswatch PRIVATE ${PROJECT_BINARY_DIR})
target_include_directories(libfswatch PRIVATE ${CMAKE_CURRENT_BINARY_DIR})
target_link_libraries(libfswatch PRIVATE ${EXTRA_LIBS})

install(TARGETS libfswatch LIBRARY DESTINATION lib)
# TODO: should migrate to target_source(file_set) to install headers
install(DIRECTORY src/libfswatch
    DESTINATION include
    FILES_MATCHING
    PATTERN "*.hpp"
    PATTERN "*.h")

## watcher 0.1.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -14,12 +14,15 @@
 # this program.  If not, see <http://www.gnu.org/licenses/>.
 #
 cmake_minimum_required(VERSION 3.14)
-project(fswatch VERSION 1.18.2 LANGUAGES C CXX)
+project(fswatch VERSION 1.19.0 LANGUAGES C CXX)
+
+set(VERSION_MODIFIER "-develop")
+set(FULL_VERSION "${PROJECT_VERSION}${VERSION_MODIFIER}")
 
 #@formatter:off
 set(PACKAGE           "${PROJECT_NAME}")
 set(PACKAGE_NAME      "${PACKAGE}")
-set(PACKAGE_VERSION   "${PROJECT_VERSION}")
+set(PACKAGE_VERSION   "${FULL_VERSION}")
 set(PACKAGE_STRING    "${PACKAGE_NAME} ${PACKAGE_VERSION}")
 set(PACKAGE_AUTHOR    "enrico.m.crisostomo@gmail.com")
 set(PACKAGE_BUGREPORT "${PACKAGE_AUTHOR}")
@@ -28,7 +31,9 @@
 set(LOCALEDIR         "${CMAKE_INSTALL_PREFIX}/share/locale" CACHE FILEPATH "locale dir")
 #@formatter:on
 
-set(CMAKE_CXX_STANDARD 17)
+if (NOT CMAKE_CXX_STANDARD)
+    set(CMAKE_CXX_STANDARD 17)
+endif ()
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 set(CMAKE_CXX_EXTENSIONS OFF)
 
@@ -48,4 +53,3 @@
 include(CheckCXXSymbolExists)
 
 add_subdirectory(libfswatch)
-

=== DESCRIPTION ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Package: watcher
 Type: Package
 Title: Watch the File System for Changes
-Version: 0.1.0
+Version: 0.1.1
 Authors@R: 
     c(person(given = "Charlie",
              family = "Gao",
@@ -27,9 +27,9 @@
 Config/testthat/edition: 3
 Config/Needs/website: tidyverse/tidytemplate
 NeedsCompilation: yes
-Packaged: 2025-02-05 21:55:22 UTC; cg334
+Packaged: 2025-02-06 20:08:58 UTC; cg334
 Author: Charlie Gao [aut, cre] (<https://orcid.org/0000-0002-0750-061X>),
   Posit Software, PBC [cph]
 Maintainer: Charlie Gao <charlie.gao@shikokuchuo.net>
 Repository: CRAN
-Date/Publication: 2025-02-06 14:20:02 UTC
+Date/Publication: 2025-02-10 08:10:02 UTC

## watcher 0.1.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -37,13 +37,10 @@
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 set(CMAKE_CXX_EXTENSIONS OFF)
 
-set(CMAKE_POSITION_INDEPENDENT_CODE ON)
-set(CMAKE_BUILD_TYPE Release)
-set(CMAKE_COLOR_MAKEFILE OFF)
-set(CMAKE_INSTALL_MESSAGE NEVER)
-
 # Add option to choose between shared and static libraries
 option(BUILD_SHARED_LIBS "Build shared libraries" OFF)
+# Add option to build libfswatch only (without fswatch or tests)
+option(BUILD_LIBS_ONLY "Build libfswatch only" OFF)
 
 # include modules
 include(FindGettext)
@@ -52,4 +49,34 @@
 include(CheckStructHasMember)
 include(CheckCXXSymbolExists)
 
+# check for gettext and libintl
+check_include_file_cxx(getopt.h HAVE_GETOPT_H)
+
+if (HAVE_GETOPT_H)
+    check_cxx_symbol_exists(getopt_long getopt.h HAVE_GETOPT_LONG)
+endif (HAVE_GETOPT_H)
+
+# If both gettext and libintl are found, define the USE_NLS variable to
+# optionally disable them
+if (Intl_FOUND AND GETTEXT_FOUND)
+    option(USE_NLS "Use NLS" ON)
+endif ()
+
+if (USE_NLS)
+    set(ENABLE_NLS 1)
+
+    # gettext configuration
+    set(LINGUAS en en@quot en@boldquot it es)
+
+    foreach (language ${LINGUAS})
+        configure_file(${PROJECT_SOURCE_DIR}/po/${language}.po ${PROJECT_BINARY_DIR}/${language}.po COPYONLY)
+    endforeach ()
+
+    gettext_process_pot_file(po/${PACKAGE}.pot ALL INSTALL_DESTINATION share/locale LANGUAGES ${LINGUAS})
+endif ()
+
 add_subdirectory(libfswatch)
+if (NOT BUILD_LIBS_ONLY)
+add_subdirectory(fswatch/src)
+add_subdirectory(test/src)
+endif ()

=== DESCRIPTION ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Package: watcher
 Type: Package
 Title: Watch the File System for Changes
-Version: 0.1.1
+Version: 0.1.2
 Authors@R: 
     c(person(given = "Charlie",
              family = "Gao",
@@ -15,21 +15,20 @@
     activity, or run an R function every time a change event occurs. 
 License: MIT + file LICENSE
 BugReports: https://github.com/r-lib/watcher/issues
-URL: https://r-lib.github.io/watcher/,
-        https://github.com/r-lib/watcher/
+URL: https://watcher.r-lib.org, https://github.com/r-lib/watcher
 Encoding: UTF-8
 SystemRequirements: 'libfswatch', or 'cmake' to compile from package
         sources
-Depends: R (>= 3.6)
+Depends: R (>= 3.5)
 Imports: later, R6, rlang
 Suggests: testthat (>= 3.0.0)
 RoxygenNote: 7.3.2
 Config/testthat/edition: 3
 Config/Needs/website: tidyverse/tidytemplate
 NeedsCompilation: yes
-Packaged: 2025-02-06 20:08:58 UTC; cg334
+Packaged: 2025-02-25 08:45:24 UTC; cg334
 Author: Charlie Gao [aut, cre] (<https://orcid.org/0000-0002-0750-061X>),
   Posit Software, PBC [cph]
 Maintainer: Charlie Gao <charlie.gao@shikokuchuo.net>
 Repository: CRAN
-Date/Publication: 2025-02-10 08:10:02 UTC
+Date/Publication: 2025-02-25 09:00:04 UTC

## watcher 0.1.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -36,6 +36,8 @@
 endif ()
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 set(CMAKE_CXX_EXTENSIONS OFF)
+
+set(CMAKE_STATIC_LIBRARY_SUFFIX ".b")
 
 # Add option to choose between shared and static libraries
 option(BUILD_SHARED_LIBS "Build shared libraries" OFF)

=== DESCRIPTION ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Package: watcher
 Type: Package
 Title: Watch the File System for Changes
-Version: 0.1.2
+Version: 0.1.3
 Authors@R: 
     c(person(given = "Charlie",
              family = "Gao",
@@ -23,12 +23,13 @@
 Imports: later, R6, rlang
 Suggests: testthat (>= 3.0.0)
 RoxygenNote: 7.3.2
+Biarch: true
 Config/testthat/edition: 3
 Config/Needs/website: tidyverse/tidytemplate
 NeedsCompilation: yes
-Packaged: 2025-02-25 08:45:24 UTC; cg334
+Packaged: 2025-04-09 22:10:26 UTC; cg334
 Author: Charlie Gao [aut, cre] (<https://orcid.org/0000-0002-0750-061X>),
   Posit Software, PBC [cph]
 Maintainer: Charlie Gao <charlie.gao@shikokuchuo.net>
 Repository: CRAN
-Date/Publication: 2025-02-25 09:00:04 UTC
+Date/Publication: 2025-04-09 22:20:02 UTC

## watcher 0.1.4

=== DESCRIPTION ===
Type: Package
Package: watcher
Title: Watch the File System for Changes
Version: 0.1.4
Authors@R: c(
    person("Charlie", "Gao", , "charlie.gao@posit.co", role = c("aut", "cre"),
           comment = c(ORCID = "0000-0002-0750-061X")),
    person("Posit Software, PBC", role = c("cph", "fnd"),
           comment = c(ROR = "03wc8by49"))
  )
Description: R binding for 'libfswatch', a file system monitoring library.
    Watch files, or directories recursively, for changes in the
    background. Log activity, or run an R function every time a change
    event occurs.
License: MIT + file LICENSE
URL: https://watcher.r-lib.org, https://github.com/r-lib/watcher
BugReports: https://github.com/r-lib/watcher/issues
Depends: R (>= 3.5)
Imports: later, R6, rlang
Suggests: testthat (>= 3.0.0)
Biarch: true
Config/Needs/website: tidyverse/tidytemplate
Config/testthat/edition: 3
Config/usethis/last-upkeep: 2025-04-23
Encoding: UTF-8
RoxygenNote: 7.3.2
SystemRequirements: 'libfswatch', or 'cmake' to compile from package
        sources
NeedsCompilation: yes
Packaged: 2025-07-16 07:06:25 UTC; shikokuchuo
Author: Charlie Gao [aut, cre] (ORCID: <https://orcid.org/0000-0002-0750-061X>),
  Posit Software, PBC [cph, fnd] (ROR: <https://ror.org/03wc8by49>)
Maintainer: Charlie Gao <charlie.gao@posit.co>
Repository: CRAN
Date/Publication: 2025-07-16 09:30:02 UTC

=== libfswatch/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #
-# Copyright (c) 2014-2024 Enrico M. Crisostomo
+# Copyright (c) 2014-2025 Enrico M. Crisostomo
 #
 # This program is free software; you can redistribute it and/or modify it under
 # the terms of the GNU General Public License as published by the Free Software
@@ -18,6 +18,10 @@
 if(APPLE)
     if (${CMAKE_SYSTEM_VERSION} VERSION_GREATER_EQUAL "9.0")
         set(HAVE_MACOS_GE_10_5 1)
+    endif()
+
+    if (${CMAKE_SYSTEM_VERSION} VERSION_GREATER_EQUAL "10.0")
+        set(HAVE_MACOS_GE_10_6 1)
     endif()
 
     if (${CMAKE_SYSTEM_VERSION} VERSION_GREATER_EQUAL "11.0")
@@ -111,25 +115,24 @@
 if (HAVE_WINDOWS_HEADER)
 
     set(LIBFSWATCH_HEADER_FILES
-                ${LIBFSWATCH_HEADER_FILES}
-                src/libfswatch/c++/windows/win_directory_change_event.hpp
-                src/libfswatch/c++/windows/win_error_message.hpp
-                src/libfswatch/c++/windows/win_handle.hpp
-                src/libfswatch/c++/windows/win_paths.hpp
-                src/libfswatch/c++/windows/win_strings.hpp
-                src/libfswatch/c++/windows_monitor.hpp)
-                
+            ${LIBFSWATCH_HEADER_FILES}
+            src/libfswatch/c++/windows/win_directory_change_event.hpp
+            src/libfswatch/c++/windows/win_error_message.hpp
+            src/libfswatch/c++/windows/win_handle.hpp
+            src/libfswatch/c++/windows/win_paths.hpp
+            src/libfswatch/c++/windows/win_strings.hpp
+            src/libfswatch/c++/windows_monitor.hpp)
+
     set(LIB_SOURCE_FILES
-                ${LIB_SOURCE_FILES}
-                src/libfswatch/c++/windows/win_directory_change_event.cpp
-                src/libfswatch/c++/windows/win_error_message.cpp
-                src/libfswatch/c++/windows/win_handle.cpp
-                src/libfswatch/c++/windows/win_paths.cpp
-                src/libfswatch/c++/windows/win_strings.cpp
-                src/libfswatch/c++/windows_monitor.cpp)
-    
+            ${LIB_SOURCE_FILES}
+            src/libfswatch/c++/windows/win_directory_change_event.cpp
+            src/libfswatch/c++/windows/win_error_message.cpp
+            src/libfswatch/c++/windows/win_handle.cpp
+            src/libfswatch/c++/windows/win_paths.cpp
+            src/libfswatch/c++/windows/win_strings.cpp
+            src/libfswatch/c++/windows_monitor.cpp)
     set(HAVE_WINDOWS ON CACHE BOOL "Enable Windows support")
-        
+
 endif (HAVE_WINDOWS_HEADER)
 
 if (APPLE)

## watcher 0.1.5

=== DESCRIPTION ===
Type: Package
Package: watcher
Title: Watch the File System for Changes
Version: 0.1.5
Authors@R: c(
    person("Charlie", "Gao", , "charlie.gao@posit.co", role = c("aut", "cre"),
           comment = c(ORCID = "0000-0002-0750-061X")),
    person("Posit Software, PBC", role = c("cph", "fnd"),
           comment = c(ROR = "03wc8by49"))
  )
Description: R binding for 'libfswatch', a file system monitoring library.
    Watch files, or directories recursively, for changes in the
    background.  Log activity, or call an R function, upon every change
    event.
License: MIT + file LICENSE
URL: https://watcher.r-lib.org, https://github.com/r-lib/watcher
BugReports: https://github.com/r-lib/watcher/issues
Depends: R (>= 3.5)
Imports: later, R6, rlang
Suggests: testthat (>= 3.0.0)
Biarch: true
Config/Needs/website: tidyverse/tidytemplate
Config/testthat/edition: 3
Config/usethis/last-upkeep: 2025-04-23
Encoding: UTF-8
RoxygenNote: 7.3.3
SystemRequirements: 'libfswatch', or 'cmake' to compile from package
        sources
NeedsCompilation: yes
Packaged: 2025-12-01 23:15:06 UTC; cg334
Author: Charlie Gao [aut, cre] (ORCID: <https://orcid.org/0000-0002-0750-061X>),
  Posit Software, PBC [cph, fnd] (ROR: <https://ror.org/03wc8by49>)
Maintainer: Charlie Gao <charlie.gao@posit.co>
Repository: CRAN
Date/Publication: 2025-12-01 23:30:02 UTC

## watcher 0.28.0

=== requirements.txt ===
# The order of packages is significant, because pip processes them in the order
# of appearance. Changing the order has an impact on the overall integration
# process, which may cause wedges in the gate later.

apscheduler # MIT License
enum34;python_version=='2.7' or python_version=='2.6' or python_version=='3.3' # BSD
jsonpatch>=1.1 # BSD
keystoneauth1>=2.7.0 # Apache-2.0
keystonemiddleware!=4.1.0,!=4.5.0,>=4.0.0 # Apache-2.0
oslo.concurrency>=3.8.0 # Apache-2.0
oslo.cache>=1.5.0 # Apache-2.0
oslo.config>=3.10.0 # Apache-2.0
oslo.context>=2.4.0 # Apache-2.0
oslo.db>=4.1.0 # Apache-2.0
oslo.i18n>=2.1.0 # Apache-2.0
oslo.log>=1.14.0 # Apache-2.0
oslo.messaging>=5.2.0 # Apache-2.0
oslo.policy>=1.9.0 # Apache-2.0
oslo.reports>=0.6.0 # Apache-2.0
oslo.service>=1.10.0 # Apache-2.0
oslo.utils>=3.14.0 # Apache-2.0
PasteDeploy>=1.5.0 # MIT
pbr>=1.6 # Apache-2.0
pecan>=1.0.0 # BSD
PrettyTable<0.8,>=0.7 # BSD
voluptuous>=0.8.9 # BSD License
python-ceilometerclient>=2.2.1 # Apache-2.0
python-cinderclient!=1.7.0,!=1.7.1,>=1.6.0 # Apache-2.0
python-glanceclient>=2.0.0 # Apache-2.0
python-keystoneclient!=1.8.0,!=2.1.0,>=1.7.0 # Apache-2.0
python-neutronclient>=4.2.0 # Apache-2.0
python-novaclient!=2.33.0,>=2.29.0 # Apache-2.0
python-openstackclient>=2.1.0 # Apache-2.0
six>=1.9.0 # MIT
SQLAlchemy<1.1.0,>=1.0.10 # MIT
stevedore>=1.10.0 # Apache-2.0
taskflow>=1.26.0 # Apache-2.0
WebOb>=1.2.3 # MIT
WSME>=0.8 # MIT

=== debian/changelog ===
watcher (0.28.0-3+2~bpo8+1) UNRELEASED; urgency=medium

  [ Thomas Goirand ]
  * Fix missing EPOC in many (build-)depends.

  [ Jenkins ]
  * Backport rebuilt by Jenkins in OpenStack infra.

 -- Jenkins <jenkins@openstack.org>  Mon, 19 Sep 2016 09:55:22 +0000

watcher (0.28.0-2) experimental; urgency=medium

  * Now requires python-apscheduler >= 3.0.5 (FTBFS otherwise).

 -- Thomas Goirand <zigo@debian.org>  Sat, 16 Jul 2016 15:37:25 +0000

watcher (0.28.0-1) experimental; urgency=medium

  * New upstream release.
  * Fixed (build-)depends for this release.

 -- Thomas Goirand <zigo@debian.org>  Sat, 16 Jul 2016 17:22:03 +0200

watcher (0.27.0-3) experimental; urgency=medium

  * Added runtime depends on net-tools for watcher-api, as the config is using
    /sbin/route.

 -- Thomas Goirand <zigo@debian.org>  Fri, 01 Jul 2016 10:38:53 +0200

watcher (0.27.0-2) experimental; urgency=medium

  * Fixed debian/copyright missing copyright holders.

 -- Thomas Goirand <zigo@debian.org>  Mon, 13 Jun 2016 08:40:12 +0000

watcher (0.27.0-1) experimental; urgency=medium

  * Initial release. (Closes: #826853)

 -- Thomas Goirand <zigo@debian.org>  Thu, 09 Jun 2016 16:03:10 +0200

=== debian/control ===
Source: watcher
Section: net
Priority: extra
Maintainer: PKG OpenStack <openstack-devel@lists.alioth.debian.org>
Uploaders: Thomas Goirand <zigo@debian.org>,
Build-Depends: debhelper (>= 9),
               dh-python,
               dh-systemd,
               openstack-pkg-tools (>= 40~),
               po-debconf,
               python-all,
               python-pbr (>= 1.8),
               python-setuptools,
               python-sphinx,
Build-Depends-Indep: python-apscheduler (>= 3.0.5),
                     python-ceilometerclient (>= 2.2.1),
                     python-cinderclient (>= 1:1.6.0),
                     python-coverage,
                     python-enum34,
                     python-freezegun,
                     python-glanceclient (>= 1:2.0.0),
                     python-hacking,
                     python-jsonpatch (>= 1.1),
                     python-keystoneauth1 (>= 2.7.0),
                     python-keystoneclient (>= 1:1.7.0),
                     python-keystonemiddleware (>= 4.0.0),
                     python-mock (>= 2.0),
                     python-neutronclient (>= 1:4.2.0),
                     python-novaclient (>= 2:2.29.0),
                     python-openstackclient (>= 2.1.0),
                     python-os-testr (>= 0.7.0),
                     python-oslo.cache (>= 1.5.0),
                     python-oslo.concurrency (>= 3.8.0),
                     python-oslo.config (>= 1:3.10.0),
                     python-oslo.context (>= 2.4.0),
                     python-oslo.db (>= 4.1.0),
                     python-oslo.i18n (>= 2.1.0),
                     python-oslo.log (>= 1.14.0),
                     python-oslo.messaging (>= 5.2.0),
                     python-oslo.policy (>= 1.9.0),
                     python-oslo.reports (>= 0.6.0),
                     python-oslo.service (>= 1.10.0),
                     python-oslo.utils (>= 3.15.0),
                     python-oslosphinx (>= 2.5.0),
                     python-oslotest (>= 1.10.0),
                     python-pastedeploy (>= 1.5.0),
                     python-pecan (>= 1.0.0),
                     python-prettytable,
                     python-six (>= 1.9.0),
                     python-sphinxcontrib-pecanwsme,
                     python-sqlalchemy (>= 1.0.10),
                     python-stevedore (>= 1.10.0),
                     python-taskflow (>= 1.26.0),
                     python-testscenarios,
                     python-testtools (>= 1.4.0),
                     python-voluptuous (>= 0.8.9),
                     python-webob,
                     python-wsme (>= 0.8),
                     subunit,
                     testrepository,
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/cgit/openstack/watcher.git/
Vcs-Git: https://anonscm.debian.org/git/openstack/watcher.git
Homepage: https://github.com/openstack/watcher

Package: python-watcher
Section: python
Architecture: all
Depends: python-apscheduler (>= 3.0.5),
         python-ceilometerclient (>= 2.2.1),
         python-cinderclient (>= 1:1.6.0),
         python-enum34,
         python-glanceclient (>= 1:2.0.0),
         python-jsonpatch (>= 1.1),
         python-keystoneauth1 (>= 2.7.0),
         python-keystoneclient (>= 1:1.7.0),
         python-keystonemiddleware (>= 4.0.0),
         python-neutronclient (>= 1:4.2.0),
         python-novaclient (>= 2:2.29.0),
         python-openstackclient (>= 2.1.0),
         python-oslo.cache (>= 1.5.0),
         python-oslo.concurrency (>= 3.8.0),
         python-oslo.config (>= 1:3.10.0),
         python-oslo.context (>= 2.4.0),
         python-oslo.db (>= 4.1.0),
         python-oslo.i18n (>= 2.1.0),
         python-oslo.log (>= 1.14.0),
         python-oslo.messaging (>= 5.2.0),
         python-oslo.policy (>= 1.9.0),
         python-oslo.reports (>= 0.6.0),
         python-oslo.service (>= 1.10.0),
         python-oslo.utils (>= 3.15.0),
         python-pastedeploy (>= 1.5.0),
         python-pbr (>= 1.8),
         python-pecan (>= 1.0.0),
         python-prettytable,
         python-six (>= 1.9.0),
         python-sqlalchemy (>= 1.0.10),
         python-stevedore (>= 1.10.0),
         python-taskflow (>= 1.26.0),
         python-voluptuous (>= 0.8.9),
         python-webob,
         python-wsme (>= 0.8),
         ${misc:Depends},
         ${python:Depends},
Description: OpenStack Cloud Optimization as a Service - Python 2.7 libraries
 OpenStack Watcher provides a flexible and scalable resource optimization
 service for multi-tenant OpenStack-based clouds. Watcher provides a complete
 optimization loop-including everything from a metrics receiver, complex event
 processor and profiler, optimization processor and an action plan applier.
 This provides a robust framework to realize a wide range of cloud optimization
 goals, including the reduction of data center operating costs, increased
 system performance via intelligent virtual machine migration, increased energy
 efficiency-and more!
 .
 This package contains the Python 2.7 libraries that are part of Watcher.

Package: watcher-common
Architecture: all
Depends: adduser,
         dbconfig-common,
         debconf,
         python-watcher (= ${binary:Version}),
         sqlite3,
         ${misc:Depends},
         ${python:Depends},
Description: OpenStack Cloud Optimization as a Service - common files
 OpenStack Watcher provides a flexible and scalable resource optimization
 service for multi-tenant OpenStack-based clouds. Watcher provides a complete
 optimization loop-including everything from a metrics receiver, complex event
 processor and profiler, optimization processor and an action plan applier.
 This provides a robust framework to realize a wide range of cloud optimization
 goals, including the reduction of data center operating costs, increased
 system performance via intelligent virtual machine migration, increased energy
 efficiency-and more!
 .
 This package contains common files and configuration that are
 needed by all the daemon packages of Watcher.

Package: watcher-api
Architecture: all
Depends: adduser,
         watcher-common (= ${binary:Version}),
         debconf,
         net-tools,
         python-keystoneclient,
         python-openstackclient,
         q-text-as-data,
         ${misc:Depends},
         ${ostack-lsb-base},
         ${python:Depends},
Description: OpenStack Cloud Optimization as a Service - API server
 OpenStack Watcher provides a flexible and scalable resource optimization
 service for multi-tenant OpenStack-based clouds. Watcher provides a complete
 optimization loop-including everything from a metrics receiver, complex event
 processor and profiler, optimization processor and an action plan applier.
 This provides a robust framework to realize a wide range of cloud optimization
 goals, including the reduction of data center operating costs, increased
 system performance via intelligent virtual machine migration, increased energy
 efficiency-and more!
 .
 This package contains the Watcher API server.

Package: watcher-decision-engine
Architecture: all
Depends: watcher-common (= ${binary:Version}),
         ${misc:Depends},
         ${ostack-lsb-base},
         ${python:Depends},
Description: OpenStack Cloud Optimization as a Service - Decision Engine
 OpenStack Watcher provides a flexible and scalable resource optimization
 service for multi-tenant OpenStack-based clouds. Watcher provides a complete
 optimization loop-including everything from a metrics receiver, complex event
 processor and profiler, optimization processor and an action plan applier.
 This provides a robust framework to realize a wide range of cloud optimization
 goals, including the reduction of data center operating costs, increased
 system performance via intelligent virtual machine migration, increased energy
 efficiency-and more!
 .
 This package contains the Watcher decision engine.

Package: watcher-applier
Architecture: all
Depends: watcher-common (= ${binary:Version}),
         ${misc:Depends},
         ${ostack-lsb-base},
         ${python:Depends},
Description: OpenStack Cloud Optimization as a Service - Applier
 OpenStack Watcher provides a flexible and scalable resource optimization
 service for multi-tenant OpenStack-based clouds. Watcher provides a complete
 optimization loop-including everything from a metrics receiver, complex event
 processor and profiler, optimization processor and an action plan applier.
 This provides a robust framework to realize a wide range of cloud optimization
 goals, including the reduction of data center operating costs, increased
 system performance via intelligent virtual machine migration, increased energy
 efficiency-and more!
 .
 This package contains the Watcher Applier.

Package: watcher-doc
Architecture: all
Section: doc
Depends: ${misc:Depends},
         ${sphinxdoc:Depends},
Description: OpenStack Cloud Optimization as a Service - doc
 OpenStack Watcher provides a flexible and scalable resource optimization
 service for multi-tenant OpenStack-based clouds. Watcher provides a complete
 optimization loop-including everything from a metrics receiver, complex event
 processor and profiler, optimization processor and an action plan applier.
 This provides a robust framework to realize a wide range of cloud optimization
 goals, including the reduction of data center operating costs, increased
 system performance via intelligent virtual machine migration, increased energy
 efficiency-and more!
 .
 This package contains the documentation.

## watcher 0.30.0

=== requirements.txt ===
# The order of packages is significant, because pip processes them in the order
# of appearance. Changing the order has an impact on the overall integration
# process, which may cause wedges in the gate later.

apscheduler # MIT License
enum34;python_version=='2.7' or python_version=='2.6' or python_version=='3.3' # BSD
jsonpatch>=1.1 # BSD
keystoneauth1>=2.10.0 # Apache-2.0
keystonemiddleware!=4.1.0,!=4.5.0,>=4.0.0 # Apache-2.0
lxml>=2.3 # BSD
oslo.concurrency>=3.8.0 # Apache-2.0
oslo.cache>=1.5.0 # Apache-2.0
oslo.config>=3.14.0 # Apache-2.0
oslo.context>=2.9.0 # Apache-2.0
oslo.db>=4.10.0 # Apache-2.0
oslo.i18n>=2.1.0 # Apache-2.0
oslo.log>=1.14.0 # Apache-2.0
oslo.messaging>=5.2.0 # Apache-2.0
oslo.policy>=1.9.0 # Apache-2.0
oslo.reports>=0.6.0 # Apache-2.0
oslo.serialization>=1.10.0 # Apache-2.0
oslo.service>=1.10.0 # Apache-2.0
oslo.utils>=3.16.0 # Apache-2.0
PasteDeploy>=1.5.0 # MIT
pbr>=1.6 # Apache-2.0
pecan!=1.0.2,!=1.0.3,!=1.0.4,>=1.0.0 # BSD
PrettyTable<0.8,>=0.7 # BSD
voluptuous>=0.8.9 # BSD License
python-ceilometerclient>=2.5.0 # Apache-2.0
python-cinderclient!=1.7.0,!=1.7.1,>=1.6.0 # Apache-2.0
python-glanceclient!=2.4.0,>=2.3.0 # Apache-2.0
python-keystoneclient!=2.1.0,>=2.0.0 # Apache-2.0
python-neutronclient>=5.1.0 # Apache-2.0
python-novaclient!=2.33.0,>=2.29.0 # Apache-2.0
python-openstackclient>=2.1.0 # Apache-2.0
six>=1.9.0 # MIT
SQLAlchemy<1.1.0,>=1.0.10 # MIT
stevedore>=1.16.0 # Apache-2.0
taskflow>=1.26.0 # Apache-2.0
WebOb>=1.2.3 # MIT
WSME>=0.8 # MIT

=== debian/changelog ===
watcher (0.30.0-2+2~bpo8+1) UNRELEASED; urgency=medium

  [ Ondřej Nový ]
  * d/s/options: extend-diff-ignore of .gitreview
  * d/control: Use correct branch in Vcs-* fields

  [ Thomas Goirand ]
  * Fixed oslotest EPOCH.

  [ Jenkins ]
  * Backport rebuilt by Jenkins in OpenStack infra.

 -- Jenkins <jenkins@openstack.org>  Wed, 28 Sep 2016 09:25:08 +0000

watcher (0.30.0-1) experimental; urgency=medium

  * New upstream release.
  * Fixed (build-)depends for this release.
  * Using OpenStack's Gerrit as VCS URLs.
  * Fix missing EPOC in many (build-)depends.

 -- Thomas Goirand <zigo@debian.org>  Mon, 19 Sep 2016 12:01:59 +0200

=== debian/control ===
--- 
+++ 
@@ -13,43 +13,45 @@
                python-setuptools,
                python-sphinx,
 Build-Depends-Indep: python-apscheduler (>= 3.0.5),
-                     python-ceilometerclient (>= 2.2.1),
+                     python-ceilometerclient (>= 2.5.0),
                      python-cinderclient (>= 1:1.6.0),
                      python-coverage,
                      python-enum34,
                      python-freezegun,
-                     python-glanceclient (>= 1:2.0.0),
+                     python-glanceclient (>= 1:2.3.0),
                      python-hacking,
                      python-jsonpatch (>= 1.1),
-                     python-keystoneauth1 (>= 2.7.0),
-                     python-keystoneclient (>= 1:1.7.0),
+                     python-keystoneauth1 (>= 2.10.0),
+                     python-keystoneclient (>= 1:2.0.0),
                      python-keystonemiddleware (>= 4.0.0),
+                     python-lxml (>= 2.3),
                      python-mock (>= 2.0),
-                     python-neutronclient (>= 1:4.2.0),
+                     python-neutronclient (>= 1:5.1.0),
                      python-novaclient (>= 2:2.29.0),
                      python-openstackclient (>= 2.1.0),
                      python-os-testr (>= 0.7.0),
                      python-oslo.cache (>= 1.5.0),
                      python-oslo.concurrency (>= 3.8.0),
-                     python-oslo.config (>= 1:3.10.0),
-                     python-oslo.context (>= 2.4.0),
-                     python-oslo.db (>= 4.1.0),
+                     python-oslo.config (>= 1:3.14.0),
+                     python-oslo.context (>= 2.9.0),
+                     python-oslo.db (>= 4.10.0),
                      python-oslo.i18n (>= 2.1.0),
                      python-oslo.log (>= 1.14.0),
                      python-oslo.messaging (>= 5.2.0),
                      python-oslo.policy (>= 1.9.0),
                      python-oslo.reports (>= 0.6.0),
+                     python-oslo.serialization (>= 1.10.0),
                      python-oslo.service (>= 1.10.0),
-                     python-oslo.utils (>= 3.15.0),
+                     python-oslo.utils (>= 3.16.0),
                      python-oslosphinx (>= 2.5.0),
-                     python-oslotest (>= 1.10.0),
+                     python-oslotest (>= 1:1.10.0),
                      python-pastedeploy (>= 1.5.0),
                      python-pecan (>= 1.0.0),
                      python-prettytable,
                      python-six (>= 1.9.0),
                      python-sphinxcontrib-pecanwsme,
                      python-sqlalchemy (>= 1.0.10),
-                     python-stevedore (>= 1.10.0),
+                     python-stevedore (>= 1.16.0),
                      python-taskflow (>= 1.26.0),
                      python-testscenarios,
                      python-testtools (>= 1.4.0),
@@ -59,44 +61,46 @@
                      subunit,
                      testrepository,
 Standards-Version: 3.9.8
-Vcs-Browser: https://anonscm.debian.org/cgit/openstack/watcher.git/
-Vcs-Git: https://anonscm.debian.org/git/openstack/watcher.git
+Vcs-Browser: https://git.openstack.org/cgit/openstack/deb-watcher?h=debian%2Fnewton
+Vcs-Git: https://git.openstack.org/openstack/deb-watcher -b debian/newton
 Homepage: https://github.com/openstack/watcher
 
 Package: python-watcher
 Section: python
 Architecture: all
 Depends: python-apscheduler (>= 3.0.5),
-         python-ceilometerclient (>= 2.2.1),
+         python-ceilometerclient (>= 2.5.0),
          python-cinderclient (>= 1:1.6.0),
          python-enum34,
-         python-glanceclient (>= 1:2.0.0),
+         python-glanceclient (>= 1:2.3.0),
          python-jsonpatch (>= 1.1),
-         python-keystoneauth1 (>= 2.7.0),
-         python-keystoneclient (>= 1:1.7.0),
+         python-keystoneauth1 (>= 2.10.0),
+         python-keystoneclient (>= 1:2.0.0),
          python-keystonemiddleware (>= 4.0.0),
-         python-neutronclient (>= 1:4.2.0),
+         python-lxml (>= 2.3),
+         python-neutronclient (>= 1:5.1.0),
          python-novaclient (>= 2:2.29.0),
          python-openstackclient (>= 2.1.0),
          python-oslo.cache (>= 1.5.0),
          python-oslo.concurrency (>= 3.8.0),
-         python-oslo.config (>= 1:3.10.0),
-         python-oslo.context (>= 2.4.0),
-         python-oslo.db (>= 4.1.0),
+         python-oslo.config (>= 1:3.14.0),
+         python-oslo.context (>= 2.9.0),
+         python-oslo.db (>= 4.10.0),
          python-oslo.i18n (>= 2.1.0),
          python-oslo.log (>= 1.14.0),
          python-oslo.messaging (>= 5.2.0),
          python-oslo.policy (>= 1.9.0),
          python-oslo.reports (>= 0.6.0),
+         python-oslo.serialization (>= 1.10.0),
          python-oslo.service (>= 1.10.0),
-         python-oslo.utils (>= 3.15.0),
+         python-oslo.utils (>= 3.16.0),
          python-pastedeploy (>= 1.5.0),
          python-pbr (>= 1.8),
          python-pecan (>= 1.0.0),
          python-prettytable,
          python-six (>= 1.9.0),
          python-sqlalchemy (>= 1.0.10),
-         python-stevedore (>= 1.10.0),
+         python-stevedore (>= 1.16.0),
          python-taskflow (>= 1.26.0),
          python-voluptuous (>= 0.8.9),
          python-webob,

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/openstack-pkg-tools/pkgos.make
export OSLO_PACKAGE_VERSION=$(shell dpkg-parsechangelog -SVersion | sed -e 's/^[[:digit:]]*://' -e 's/[-].*//' -e 's/~/.0/' | head -n 1)

%:
	dh $@ --buildsystem=python_distutils --with python2,systemd,sphinxdoc

override_dh_clean:
	dh_clean
	rm -f debian/watcher-common.config debian/watcher-common.postinst debian/watcher-api.config debian/watcher-api.postinst
	rm -rf debian/*.upstart debian/*.service

override_dh_auto_build:
	dh_auto_build -O--buildsystem=python_distutils

	/usr/share/openstack-pkg-tools/pkgos_insert_include pkgos_func watcher-common.config
	/usr/share/openstack-pkg-tools/pkgos_insert_include pkgos_func watcher-common.postinst
	/usr/share/openstack-pkg-tools/pkgos_insert_include pkgos_func watcher-api.config
	/usr/share/openstack-pkg-tools/pkgos_insert_include pkgos_func watcher-api.postinst

override_dh_auto_install:
	echo "Do nothing..."

override_dh_install:
	python2.7 setup.py install --install-layout=deb --root $(CURDIR)/debian/tmp

	rm -rf $(CURDIR)/debian/tmp/usr/etc

	mkdir -p $(CURDIR)/debian/watcher-common/usr/share/watcher-common
	PYTHONPATH=$(CURDIR)/debian/tmp/usr/lib/python2.7/dist-packages oslo-config-generator \
		--output-file $(CURDIR)/debian/watcher-common/usr/share/watcher-common/watcher.conf \
		--wrap-width 140 \
		--namespace watcher \
		--namespace keystonemiddleware.auth_token \
		--namespace oslo.log \
		--namespace oslo.db \
		--namespace oslo.messaging
	dh_install --fail-missing

	# Disable https in default setup, as this makes our CI fail
	pkgos-fix-config-default $(CURDIR)/debian/watcher-common/usr/share/watcher-common/watcher.conf keystone_authtoken auth_protocol http

	# Fix the missing sql_connection directive
	pkgos-fix-config-default $(CURDIR)/debian/watcher-common/usr/share/watcher-common/watcher.conf database sqlite:////var/lib/watcher/watcherdb

override_dh_auto_test:
ifeq (,$(findstring nocheck, $(DEB_BUILD_OPTIONS)))
	@echo "===> Running tests"
	set -e ; set -x ; for i in 2.7 ; do \
		PYMAJOR=`echo $$i | cut -d'.' -f1` ; \
		echo "===> Testing with python$$i (python$$PYMAJOR)" ; \
		rm -rf .testrepository ; \
		testr-python$$PYMAJOR init ; \
		TEMP_REZ=`mktemp -t` ; \
		PYTHONPATH=$(CURDIR) PYTHON=python$$i testr-python$$PYMAJOR run --subunit 'watcher\.tests\.(?!.*api\.test_hooks\.TestContextHook\.test_context_hook_before_method.*)' | tee $$TEMP_REZ | subunit2pyunit ; \
		cat $$TEMP_REZ | subunit-filter -s --no-passthrough | subunit-stats ; \
		rm -f $$TEMP_REZ ; \
		testr-python$$PYMAJOR slowest ; \
	done
endif


override_dh_sphinxdoc:
ifeq (,$(findstring nodocs, $(DEB_BUILD_OPTIONS)))
	PYTHONPATH=. sphinx-build $(SPHINXOPTS) -b html doc/source $(CURDIR)/debian/watcher-doc/usr/share/doc/watcher-doc/html
	touch $(CURDIR)/debian/watcher-doc/usr/share/doc/watcher-doc/html/_static/toggle.js
	dh_sphinxdoc
endif
